##########################################################################################
################################## SOFTWARE R - CAST 5 ###################################
##########################################################################################

# Nastaveni pracovniho adresare - napr.:
setwd("c:/Users/janousova/Documents/Vyuka/DSAN01 - Analyza dat pro neurovedy/2013 jaro/Materialy/Rko")


############### Nacteni dat a jejich zobrazeni ###############

kardio <- read.table(file="Data_pro_R.txt", sep="\t", dec=".", header=T) # nacteni dat


############### Analyza kontingencnich tabulek ###############

### Pearsonuv chi-kvadrat test:

kardio$vek.3kat <- 1+(kardio$vek>=30)+(kardio$vek>=50) # vytvoreni trech kategorii: 1...<30, 2...30-50, 3...>=50
summary(as.factor(kardio$vek.3kat))
summary(as.factor(kardio$cel_chol_norma)) # 0...pod normou, 1...v norme, 2...pod normou
test <- chisq.test(kardio$vek.3kat,kardio$cel_chol_norma) 
test
test$observed
test$expected

kt <- table(kardio$vek.3kat,kardio$cel_chol_norma)
kt
kt.procenta <- prop.table(kt,1)   # kontingencni tabulka procent (radkova procenta)
addmargins(kt.procenta)


### Fisheruv exaktni test:

kt <- table(kardio$pohlavi_rek,kardio$risk_kat)
kt
kt.procenta <- prop.table(kt,1)   # kontingencni tabulka procent (radkova procenta)
addmargins(kt.procenta)
fisher.test(kardio$pohlavi_rek,kardio$risk_kat) 


### Vyjadreni rizik ve ctyrpolni tabulce - relativni riziko a pomer sanci:

# POMER SANCI (ODDS RATIO):
kt <- table(kardio$pohlavi_rek,kardio$risk_kat)
kt
prop.table(kt,1)
OR <- (kt[1,1]/kt[2,1])/(kt[1,2]/kt[2,2])
OR
OR <- (kt[1,1]*kt[2,2])/(kt[1,2]*kt[2,1]) # totez, co predchozi
OR
# tzn. Sance na vyskyt kardiologickeho onemocneni je 6.9-krat vyssi u muzu nez u zen.  

risk <- array(0,length(kardio$risk_kat))
risk[kardio$risk_kat=="H"] <- 1
kt <- table(kardio$pohlavi_rek,risk)
kt
OR <- (kt[1,1]*kt[2,2])/(kt[1,2]*kt[2,1]) # totez, co predchozi
OR
1/OR

pohlavi <- array(0,length(kardio$pohlavi_rek))
pohlavi[kardio$pohlavi_rek=="M"] <- 1
kt <- table(pohlavi,risk)
kt
OR <- (kt[1,1]*kt[2,2])/(kt[1,2]*kt[2,1]) # totez, co predchozi
OR

# dalsi zpusoby vypoctu pomeru sanci (OR):
fisher.test(kardio$pohlavi_rek,kardio$risk_kat) 
install.packages("epitools")
library(epitools)
oddsratio(kardio$pohlavi_rek,kardio$risk_kat) # IS neobsahuje jednicku, zamitame nulovou hypotezu o nezavislosti rizika na pohlavi


# RELATIVNI RIZIKO (RELATIVE RISK):
kt <- table(kardio$pohlavi_rek,kardio$risk_kat)
kt
RR <- (kt[1,1]/(kt[1,1]+kt[2,1]))/(kt[1,2]/(kt[1,2]+kt[2,2]))
RR
# Riziko vyskytu kardiologickeho onemocneni je temer 3x vyssi u muzu nez u zen.


### McNemaruv test:
kt <- table(kardio$risk_kat,kardio$risk_60_kat) # risk_kat - riziko v soucasnem veku, risk_60_kat - riziko v 60 letech
kt
risk <- kardio$risk_kat[kardio$risk_60_kat!=""]
risk_60 <- as.factor(kardio$risk_60_kat[kardio$risk_60_kat!=""])
kt <- table(risk,risk_60)
kt 
risk_60_new <- array(0,length(risk_60)) # rekodovani do nove promenne, abychom se skutecne zbavili kategorie "" 
risk_60_new[risk_60=="H"] <- "H"
risk_60_new[risk_60=="L"] <- "L"
kt <- table(risk,risk_60_new)
kt # je patrne, ze 12 lidi, kteri byli pri prvnim vysetreni v kategorii "L", preslo v 60-ti letech do kategorie "H"
mcnemar.test(risk,risk_60_new)



########################################################################################################################

############### Korelace ###############

# Priklad: Overte vztah celkoveho cholesterolu a LDL cholesterolu.

# Bodovy graf:
plot(kardio$ldl_cholesterol,kardio$cel_cholesterol)

# Pearsonuv korelacni koeficient:
cor.test(kardio$cel_cholesterol,kardio$ldl_cholesterol)

# Spearmanuv korelacni koeficient:
cor.test(kardio$cel_cholesterol,kardio$ldl_cholesterol,method="spearman")

# Parove korelace:
cor(cbind(kardio$cel_cholesterol,kardio$ldl_cholesterol))
cor(kardio[,10:16]) # je patrne, ze jsou tam nejake chybejici hodnoty
nevalidni <- (rowSums(is.na(kardio[,10:16]))>0) # nalezeni radku s chybejicimi hodnotami
kardio.valid <- kardio[!nevalidni,] # vytvoreni validniho souboru
cor(kardio.valid[,10:16]) 


############### Linearni regrese ###############

y=kardio$cel_cholesterol
x=kardio$ldl_cholesterol
lin.model <- lm(y~x)
plot(x,y)
lines(x,as.numeric(lin.model$coefficients[1])+as.numeric(lin.model$coefficients[2])*x,col="red")




